﻿Option Strict On
Option Explicit On
Public Class Form1

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
        'Allow the drag and drop operations of all the group-box controls
        groupBoxBargesInRepair.AllowDrop = True : groupBoxBargesInStandby.AllowDrop = True : groupBoxBoatsInRepair.AllowDrop = True : groupBoxBoatsInStandby.AllowDrop = True : groupBoxPairs.AllowDrop = True

        Dim merleGonsoulin As Boat = New Boat With {.AllowDrop = True, .BackColor = Color.Green, .Breadth = 34, .Depth = 10, .Engine = "Cummins KT38M", .Horsepower = 2000, .Length = 78, .Name = "Merle Gonsoulin", .OfficalNumber = "1270118", .Weight = 222, .YearBuilt = 2016}
        Dim gonsoulin546 As Barge = New Barge With {.BackColor = Color.Red, .Depth = 12, .Heater = "Volcanic 8M BTU", .Length = 297, .Name = "Gonsoulin 546", .OfficalNumber = "1263066", .Width = 54, .Weight = 30000, .YearBuilt = 2015}
        Dim gonsoulin528 As Barge = New Barge With {.BackColor = Color.Red, .Depth = 12, .Heater = "Volcanic 8M BTU", .Length = 297, .Name = "Gonsoulin 528", .OfficalNumber = "1263066", .Weight = 30000, .Width = 54, .YearBuilt = 2012}

        'Add the event handlers for the boat/barge
        AddHandler merleGonsoulin.DragEnter, AddressOf boat_DragEnter
        AddHandler merleGonsoulin.DragDrop, AddressOf boat_DragDrop
        AddHandler merleGonsoulin.MouseDown, AddressOf boat_MouseDown
        AddHandler merleGonsoulin.MouseMove, AddressOf boat_MouseMove
        AddHandler gonsoulin546.MouseDown, AddressOf barge_MouseDown
        AddHandler gonsoulin546.MouseMove, AddressOf barge_MouseMove
        AddHandler gonsoulin528.MouseDown, AddressOf barge_MouseDown
        AddHandler gonsoulin528.MouseMove, AddressOf barge_MouseMove

        Me.AddPair(merleGonsoulin, {gonsoulin546, gonsoulin528})
    End Sub

    Private Sub AddPair(ByVal _boat As Boat, ByVal _barges() As Barge)
        Dim flpPair As FlowLayoutPanel = New FlowLayoutPanel() With {.Dock = DockStyle.Top, .FlowDirection = FlowDirection.LeftToRight, .Padding = New Padding(0)}

        'Add the boat first
        flpPair.Controls.Add(_boat)

        'Add the barges next
        flpPair.Controls.AddRange(_barges)

        groupBoxPairs.Controls.Add(flpPair)
    End Sub

    Private m_BargeMouseIsDown As Boolean = False
    Private Sub barge_MouseDown(ByVal sender As Object, ByVal e As MouseEventArgs)
        m_BargeMouseIsDown = True
    End Sub

    Private Sub barge_MouseMove(ByVal sender As Object, ByVal e As MouseEventArgs)
        If m_BargeMouseIsDown Then
            Dim m_barge As Barge = DirectCast(sender, Barge)
            m_barge.DoDragDrop(m_barge.Name, DragDropEffects.Move)
        End If
        m_BargeMouseIsDown = False
    End Sub

    Private m_BoatMouseIsDown As Boolean = False
    Private Sub boat_MouseDown(ByVal sender As Object, ByVal e As MouseEventArgs)
        m_BoatMouseIsDown = True
    End Sub

    Private Sub boat_MouseMove(ByVal sender As Object, ByVal e As MouseEventArgs)
        If m_BoatMouseIsDown Then
            Dim m_boat As Boat = DirectCast(sender, Boat)
            m_boat.DoDragDrop(m_boat.Name, DragDropEffects.Move)
        End If
        m_BoatMouseIsDown = False
    End Sub

    Private Sub groupBoxBarges_DragEnter(ByVal sender As Object, e As DragEventArgs) Handles groupBoxBargesInStandby.DragEnter, groupBoxBargesInRepair.DragEnter
        Dim _barge As Control = groupBoxPairs.Controls.Find(e.Data.GetData(DataFormats.Text).ToString, True).FirstOrDefault

        'Check the format of the data being dropped.
        If (e.Data.GetDataPresent(DataFormats.Text)) AndAlso _barge IsNot Nothing AndAlso _barge.GetType() Is GetType(Barge) Then
            'Display the copy cursor.
            e.Effect = DragDropEffects.Move
        Else
            'Display the no-drop cursor.
            e.Effect = DragDropEffects.None
        End If
    End Sub

    Private Sub groupBoxBarges_DragDrop(ByVal sender As Object, e As DragEventArgs) Handles groupBoxBargesInStandby.DragDrop, groupBoxBargesInRepair.DragDrop
        Dim _barge As Control = groupBoxPairs.Controls.Find(e.Data.GetData(DataFormats.Text).ToString, True).FirstOrDefault

        'Move the barge to the respective groupbox
        If _barge IsNot Nothing Then
            _barge.Parent = DirectCast(sender, GroupBox)
            _barge.Dock = DockStyle.Top
        End If
    End Sub

    Private Sub groupBoxBoats_DragEnter(ByVal sender As Object, e As DragEventArgs) Handles groupBoxBoatsInStandby.DragEnter, groupBoxBoatsInRepair.DragEnter
        Dim _boat As Control = groupBoxPairs.Controls.Find(e.Data.GetData(DataFormats.Text).ToString, True).FirstOrDefault

        'Check the format of the data being dropped.
        If (e.Data.GetDataPresent(DataFormats.Text)) AndAlso _boat IsNot Nothing AndAlso _boat.GetType() Is GetType(Boat) Then
            'Display the copy cursor.
            e.Effect = DragDropEffects.Move
        Else
            'Display the no-drop cursor.
            e.Effect = DragDropEffects.None
        End If
    End Sub

    Private Sub groupBoxBoats_DragDrop(ByVal sender As Object, e As DragEventArgs) Handles groupBoxBoatsInStandby.DragDrop, groupBoxBoatsInRepair.DragDrop
        Dim _boat As Control = groupBoxPairs.Controls.Find(e.Data.GetData(DataFormats.Text).ToString, True).FirstOrDefault

        'Move the barge to the respective groupbox
        If _boat IsNot Nothing AndAlso _boat.Parent.Controls.Count = 1 Then
            _boat.Parent = DirectCast(sender, GroupBox)
            _boat.Dock = DockStyle.Top
        ElseIf _boat IsNot Nothing Then
            MessageBox.Show("Please remove all barges from the boat first.", "Child Assets Attached", MessageBoxButtons.OK)
        End If
    End Sub

    Private Sub boat_DragEnter(ByVal sender As Object, ByVal e As DragEventArgs)
        Dim _barge As Control = groupBoxBargesInStandby.Controls.Find(e.Data.GetData(DataFormats.Text).ToString, True).FirstOrDefault
        If _barge Is Nothing Then _barge = groupBoxBargesInRepair.Controls.Find(e.Data.GetData(DataFormats.Text).ToString, True).FirstOrDefault

        'Check the format of the data being dropped.
        If (e.Data.GetDataPresent(DataFormats.Text)) AndAlso _barge IsNot Nothing AndAlso _barge.GetType() Is GetType(Barge) Then
            'Display the copy cursor.
            e.Effect = DragDropEffects.Move
        Else
            'Display the no-drop cursor.
            e.Effect = DragDropEffects.None
        End If
    End Sub

    Private Sub boat_DragDrop(ByVal sender As Object, ByVal e As DragEventArgs)
        'Move the control to the groupBox
        Dim _barge As Control = groupBoxBargesInStandby.Controls.Find(e.Data.GetData(DataFormats.Text).ToString, True).FirstOrDefault
        If _barge Is Nothing Then _barge = groupBoxBargesInRepair.Controls.Find(e.Data.GetData(DataFormats.Text).ToString, True).FirstOrDefault

        'Move the barge to the boat
        If _barge IsNot Nothing Then
            _barge.Parent = DirectCast(sender, Boat).Parent
            _barge.Dock = DockStyle.None
        End If
    End Sub

End Class